Index: serefpolicy-contrib-20140730/samba.if
===================================================================
--- serefpolicy-contrib-20140730.orig/samba.if
+++ serefpolicy-contrib-20140730/samba.if
@@ -1,8 +1,12 @@
-## <summary>SMB and CIFS client/server programs.</summary>
+## <summary>
+##	SMB and CIFS client/server programs for UNIX and
+##	name  Service  Switch  daemon for resolving names
+##	from Windows NT servers.
+## </summary>
 
 ########################################
 ## <summary>
-##	Execute nmbd in the nmbd domain.
+##	Execute nmbd net in the nmbd_t domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -21,7 +25,7 @@ interface(`samba_domtrans_nmbd',`
 
 #######################################
 ## <summary>
-##	Send generic signals to nmbd.
+##	Allow domain to signal samba
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -38,8 +42,26 @@ interface(`samba_signal_nmbd',`
 
 ########################################
 ## <summary>
-##	Connect to nmbd with a unix domain
-##	stream socket.
+##	Search the samba pid directory.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain to not audit.
+##	</summary>
+## </param>
+#
+interface(`samba_search_pid',`
+	gen_require(`
+		type smbd_var_run_t;
+	')
+
+	files_search_pids($1)
+	allow $1 smbd_var_run_t:dir search_dir_perms;
+')
+
+########################################
+## <summary>
+##	Connect to nmbd.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -49,17 +71,16 @@ interface(`samba_signal_nmbd',`
 #
 interface(`samba_stream_connect_nmbd',`
 	gen_require(`
-		type samba_var_t, nmbd_t, nmbd_var_run_t, smbd_var_run_t;
+		type nmbd_t, nmbd_var_run_t;
 	')
 
-	files_search_pids($1)
-	stream_connect_pattern($1, { smbd_var_run_t samba_var_t nmbd_var_run_t }, nmbd_var_run_t, nmbd_t)
+	samba_search_pid($1)
+	stream_connect_pattern($1, nmbd_var_run_t, nmbd_var_run_t, nmbd_t)
 ')
 
 ########################################
 ## <summary>
-##	Execute samba init scripts in
-##	the init script domain.
+##	Execute samba server in the samba domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -77,7 +98,30 @@ interface(`samba_initrc_domtrans',`
 
 ########################################
 ## <summary>
-##	Execute samba net in the samba net domain.
+##	Execute samba server in the samba domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+#
+interface(`samba_systemctl',`
+	gen_require(`
+		type samba_unit_file_t;
+		type smbd_t;
+	')
+
+	systemd_exec_systemctl($1)
+	allow $1 samba_unit_file_t:file read_file_perms;
+	allow $1 samba_unit_file_t:service manage_service_perms;
+
+	ps_process_pattern($1, smbd_t)
+')
+
+########################################
+## <summary>
+##	Execute samba net in the samba_net domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -96,9 +140,27 @@ interface(`samba_domtrans_net',`
 
 ########################################
 ## <summary>
-##	Execute samba net in the samba net
-##	domain, and allow the specified
-##	role the samba net domain.
+##	Execute samba net in the samba_unconfined_net domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+#
+interface(`samba_domtrans_unconfined_net',`
+	gen_require(`
+		type samba_unconfined_net_t, samba_net_exec_t;
+	')
+
+	corecmd_search_bin($1)
+	domtrans_pattern($1, samba_net_exec_t, samba_unconfined_net_t)
+')
+
+########################################
+## <summary>
+##	Execute samba net in the samba_net domain, and
+##	allow the specified role the samba_net domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -114,11 +176,56 @@ interface(`samba_domtrans_net',`
 #
 interface(`samba_run_net',`
 	gen_require(`
-		attribute_role samba_net_roles;
+		type samba_net_t;
 	')
 
 	samba_domtrans_net($1)
-	roleattribute $2 samba_net_roles;
+	role $2 types samba_net_t;
+')
+
+#######################################
+## <summary>
+##	The role for the samba module.
+## </summary>
+## <param name="role">
+##	<summary>
+##	The role to be allowed the samba_net domain.
+##	</summary>
+## </param>
+## <rolecap/>
+#
+interface(`samba_role_notrans',`
+	gen_require(`
+		type smbd_t;
+	')
+
+	role $1 types smbd_t;
+')
+
+########################################
+## <summary>
+##	Execute samba net in the samba_unconfined_net domain, and
+##	allow the specified role the samba_unconfined_net domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+## <param name="role">
+##	<summary>
+##	The role to be allowed the samba_unconfined_net domain.
+##	</summary>
+## </param>
+## <rolecap/>
+#
+interface(`samba_run_unconfined_net',`
+	gen_require(`
+		type samba_unconfined_net_t;
+	')
+
+	samba_domtrans_unconfined_net($1)
+	role $2 types samba_unconfined_net_t;
 ')
 
 ########################################
@@ -142,9 +249,8 @@ interface(`samba_domtrans_smbmount',`
 
 ########################################
 ## <summary>
-##	Execute smbmount in the smbmount
-##	domain, and allow the specified
-##	role the smbmount domain.
+##	Execute smbmount interactively and do
+##	a domain transition to the smbmount domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -160,16 +266,17 @@ interface(`samba_domtrans_smbmount',`
 #
 interface(`samba_run_smbmount',`
 	gen_require(`
-		attribute_role smbmount_roles;
+		type smbmount_t;
 	')
 
 	samba_domtrans_smbmount($1)
-	roleattribute $2 smbmount_roles;
+	role $2 types smbmount_t;
 ')
 
 ########################################
 ## <summary>
-##	Read samba configuration files.
+##	Allow the specified domain to read
+##	samba configuration files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -184,12 +291,14 @@ interface(`samba_read_config',`
 	')
 
 	files_search_etc($1)
+	list_dirs_pattern($1, samba_etc_t, samba_etc_t)
 	read_files_pattern($1, samba_etc_t, samba_etc_t)
 ')
 
 ########################################
 ## <summary>
-##	Read and write samba configuration files.
+##	Allow the specified domain to read
+##	and write samba configuration files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -209,8 +318,8 @@ interface(`samba_rw_config',`
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	samba configuration files.
+##	Allow the specified domain to read
+##	and write samba configuration files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -231,7 +340,7 @@ interface(`samba_manage_config',`
 
 ########################################
 ## <summary>
-##	Read samba log files.
+##	Allow the specified domain to read samba's log files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -252,7 +361,7 @@ interface(`samba_read_log',`
 
 ########################################
 ## <summary>
-##	Append to samba log files.
+##	Allow the specified domain to append to samba's log files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -273,7 +382,7 @@ interface(`samba_append_log',`
 
 ########################################
 ## <summary>
-##	Execute samba log files in the caller domain.
+##	Execute samba log in the caller domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -292,7 +401,7 @@ interface(`samba_exec_log',`
 
 ########################################
 ## <summary>
-##	Read samba secret files.
+##	Allow the specified domain to read samba's secrets.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -311,7 +420,7 @@ interface(`samba_read_secrets',`
 
 ########################################
 ## <summary>
-##	Read samba share files.
+##	Allow the specified domain to read samba's shares
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -330,7 +439,8 @@ interface(`samba_read_share_files',`
 
 ########################################
 ## <summary>
-##	Search samba var directories.
+##	Allow the specified domain to search
+##	samba /var directories.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -343,13 +453,15 @@ interface(`samba_search_var',`
 		type samba_var_t;
 	')
 
+	files_search_var($1)
 	files_search_var_lib($1)
 	allow $1 samba_var_t:dir search_dir_perms;
 ')
 
 ########################################
 ## <summary>
-##	Read samba var files.
+##	Allow the specified domain to
+##	read samba /var files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -362,14 +474,15 @@ interface(`samba_read_var_files',`
 		type samba_var_t;
 	')
 
+	files_search_var($1)
 	files_search_var_lib($1)
 	read_files_pattern($1, samba_var_t, samba_var_t)
 ')
 
 ########################################
 ## <summary>
-##	Do not audit attempts to write
-##	samba var files.
+##	Do not audit attempts to write samba
+##	/var files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -387,7 +500,8 @@ interface(`samba_dontaudit_write_var_fil
 
 ########################################
 ## <summary>
-##	Read and write samba var files.
+##	Allow the specified domain to
+##	read and write samba /var files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -400,14 +514,15 @@ interface(`samba_rw_var_files',`
 		type samba_var_t;
 	')
 
+	files_search_var($1)
 	files_search_var_lib($1)
 	rw_files_pattern($1, samba_var_t, samba_var_t)
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	samba var files.
+##	Allow the specified domain to
+##	read and write samba /var files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -421,33 +536,34 @@ interface(`samba_manage_var_files',`
 	')
 
 	files_search_var_lib($1)
+	files_search_var_lib($1)
 	manage_files_pattern($1, samba_var_t, samba_var_t)
+	manage_lnk_files_pattern($1, samba_var_t, samba_var_t)
 ')
 
 ########################################
 ## <summary>
-##	Execute smbcontrol in the smbcontrol domain.
+##	Execute a domain transition to run smbcontrol.
 ## </summary>
 ## <param name="domain">
-##	<summary>
+## <summary>
 ##	Domain allowed to transition.
-##	</summary>
+## </summary>
 ## </param>
 #
 interface(`samba_domtrans_smbcontrol',`
 	gen_require(`
-		type smbcontrol_t, smbcontrol_exec_t;
+		type smbcontrol_t;
+		type smbcontrol_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	domtrans_pattern($1, smbcontrol_exec_t, smbcontrol_t)
 ')
 
 ########################################
 ## <summary>
-##	Execute smbcontrol in the smbcontrol
-##	domain, and allow the specified
-##	role the smbcontrol domain.
+##	Execute smbcontrol in the smbcontrol domain, and
+##	allow the specified role the smbcontrol domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -462,16 +578,16 @@ interface(`samba_domtrans_smbcontrol',`
 #
 interface(`samba_run_smbcontrol',`
 	gen_require(`
-		attribute_role smbcontrol_roles;
+		type smbcontrol_t;
 	')
 
 	samba_domtrans_smbcontrol($1)
-	roleattribute $2 smbcontrol_roles;
+	role $2 types smbcontrol_t;
 ')
 
 ########################################
 ## <summary>
-##	Execute smbd in the smbd domain.
+##	Execute smbd in the smbd_t domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -490,7 +606,7 @@ interface(`samba_domtrans_smbd',`
 
 ######################################
 ## <summary>
-##	Send generic signals to smbd.
+##	Allow domain to signal samba
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -507,8 +623,7 @@ interface(`samba_signal_smbd',`
 
 ########################################
 ## <summary>
-##	Do not audit attempts to inherit
-##	and use smbd file descriptors.
+##	Do not audit attempts to use file descriptors from samba.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -526,7 +641,7 @@ interface(`samba_dontaudit_use_fds',`
 
 ########################################
 ## <summary>
-##	Write smbmount tcp sockets.
+##	Allow the specified domain to write to smbmount tcp sockets.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -544,7 +659,7 @@ interface(`samba_write_smbmount_tcp_sock
 
 ########################################
 ## <summary>
-##	Read and write smbmount tcp sockets.
+##	Allow the specified domain to read and write to smbmount tcp sockets.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -560,49 +675,47 @@ interface(`samba_rw_smbmount_tcp_sockets
 	allow $1 smbmount_t:tcp_socket { read write };
 ')
 
-########################################
+#######################################
 ## <summary>
-##	Execute winbind helper in the
-##	winbind helper domain.
+##  Allow to getattr on winbind binary.
 ## </summary>
 ## <param name="domain">
-##	<summary>
-##	Domain allowed to transition.
-##	</summary>
+##  <summary>
+##  Domain allowed to transition.
+##  </summary>
 ## </param>
 #
-interface(`samba_domtrans_winbind_helper',`
-	gen_require(`
-		type winbind_helper_t, winbind_helper_exec_t;
-	')
+interface(`samba_getattr_winbind',`
+    gen_require(`
+        type winbind_exec_t;
+    ')
 
-	corecmd_search_bin($1)
-	domtrans_pattern($1, winbind_helper_exec_t, winbind_helper_t)
+	allow $1 winbind_exec_t:file getattr;
 ')
 
-#######################################
+########################################
 ## <summary>
-##	Get attributes of winbind executable files.
+##	Execute winbind_helper in the winbind_helper domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##	Domain allowed to transition.
 ##	</summary>
 ## </param>
 #
-interface(`samba_getattr_winbind_exec',`
+interface(`samba_domtrans_winbind_helper',`
 	gen_require(`
-		type winbind_exec_t;
+		type winbind_helper_t, winbind_helper_exec_t;
 	')
 
-	allow $1 winbind_exec_t:file getattr_file_perms;
+	domtrans_pattern($1, winbind_helper_exec_t, winbind_helper_t)
+	allow $1 winbind_helper_t:process signal;
 ')
 
 ########################################
 ## <summary>
-##	Execute winbind helper in the winbind
-##	helper domain, and allow the specified
-##	role the winbind helper domain.
+##	Execute winbind_helper in the winbind_helper domain, and
+##	allow the specified role the winbind_helper domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -618,16 +731,16 @@ interface(`samba_getattr_winbind_exec',`
 #
 interface(`samba_run_winbind_helper',`
 	gen_require(`
-		attribute_role winbind_helper_roles;
+		type winbind_helper_t;
 	')
 
 	samba_domtrans_winbind_helper($1)
-	roleattribute $2 winbind_helper_roles;
+	role $2 types winbind_helper_t;
 ')
 
 ########################################
 ## <summary>
-##	Read winbind pid files.
+##	Allow the specified domain to read the winbind pid files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -637,17 +750,16 @@ interface(`samba_run_winbind_helper',`
 #
 interface(`samba_read_winbind_pid',`
 	gen_require(`
-		type winbind_var_run_t, smbd_var_run_t;
+		type winbind_var_run_t;
 	')
 
-	files_search_pids($1)
-	read_files_pattern($1, { smbd_var_run_t winbind_var_run_t }, winbind_var_run_t)
+	samba_search_pid($1)
+	allow $1 winbind_var_run_t:file read_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Connect to winbind with a unix
-##	domain stream socket.
+##	Connect to winbind.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -657,17 +769,61 @@ interface(`samba_read_winbind_pid',`
 #
 interface(`samba_stream_connect_winbind',`
 	gen_require(`
-		type samba_var_t, winbind_t, winbind_var_run_t, smbd_var_run_t;
+		type samba_var_t, winbind_t, winbind_var_run_t;
 	')
 
-	files_search_pids($1)
-	stream_connect_pattern($1, { smbd_var_run_t samba_var_t winbind_var_run_t }, winbind_var_run_t, winbind_t)
+	samba_search_pid($1)
+	allow $1 samba_var_t:dir search_dir_perms;
+	stream_connect_pattern($1, winbind_var_run_t, winbind_var_run_t, winbind_t)
+	samba_read_config($1)
+
+	ifndef(`distro_redhat',`
+		gen_require(`
+			type winbind_tmp_t;
+		')
+
+		# the default for the socket is (poorly named):
+		# /tmp/.winbindd/pipe
+		files_search_tmp($1)
+		stream_connect_pattern($1, winbind_tmp_t, winbind_tmp_t, winbind_t)
+	')
 ')
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an samba environment.
+##	Create a set of derived types for apache
+##	web content.
+## </summary>
+## <param name="prefix">
+##	<summary>
+##	The prefix to be used for deriving type names.
+##	</summary>
+## </param>
+#
+template(`samba_helper_template',`
+	gen_require(`
+		type smbd_t;
+		role system_r;
+	')
+
+	#This type is for samba helper scripts
+	type samba_$1_script_t;
+	domain_type(samba_$1_script_t)
+	role system_r types samba_$1_script_t;
+
+	# This type is used for executable scripts files
+	type samba_$1_script_exec_t;
+	corecmd_shell_entry_type(samba_$1_script_t)
+	domain_entry_file(samba_$1_script_t, samba_$1_script_exec_t)
+
+	domtrans_pattern(smbd_t, samba_$1_script_exec_t, samba_$1_script_t)
+	allow smbd_t samba_$1_script_exec_t:file ioctl;
+')
+
+########################################
+## <summary>
+##	All of the rules required to administrate 
+##	an samba environment
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -676,7 +832,7 @@ interface(`samba_stream_connect_winbind'
 ## </param>
 ## <param name="role">
 ##	<summary>
-##	Role allowed access.
+##	The role to be allowed to manage the samba domain.
 ##	</summary>
 ## </param>
 ## <rolecap/>
@@ -689,11 +845,28 @@ interface(`samba_admin',`
 		type samba_etc_t, samba_share_t, samba_initrc_exec_t;
 		type swat_var_run_t, swat_tmp_t, winbind_log_t;
 		type winbind_var_run_t, winbind_tmp_t;
-		type smbd_keytab_t;
+		type smbd_keytab_t, samba_unit_file_t;
+	')
+
+	allow $1 smbd_t:process signal_perms;
+	ps_process_pattern($1, smbd_t)
+
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 smbd_t:process ptrace;
+		allow $1 nmbd_t:process ptrace;
+		allow $1 samba_unconfined_script_t:process ptrace;
 	')
 
-	allow $1 { nmbd_t smbd_t }:process { ptrace signal_perms };
-	ps_process_pattern($1, { nmbd_t smbd_t })
+	allow $1 nmbd_t:process signal_perms;
+	ps_process_pattern($1, nmbd_t)
+
+	allow $1 samba_unconfined_script_t:process signal_perms;
+	ps_process_pattern($1, samba_unconfined_script_t)
+
+	samba_run_smbcontrol($1, $2)
+	samba_run_winbind_helper($1, $2)
+	samba_run_smbmount($1, $2)
+	samba_run_net($1, $2)
 
 	init_labeled_script_domtrans($1, samba_initrc_exec_t)
 	domain_system_change_exemption($1)
@@ -703,23 +876,34 @@ interface(`samba_admin',`
 	files_list_etc($1)
 	admin_pattern($1, { samba_etc_t smbd_keytab_t })
 
+	admin_pattern($1, samba_log_t)
 	logging_list_logs($1)
-	admin_pattern($1, { samba_log_t winbind_log_t })
 
-	files_list_var($1)
-	admin_pattern($1, { samba_share_t samba_var_t samba_secrets_t })
+	admin_pattern($1, samba_secrets_t)
 
-	files_list_spool($1)
-	admin_pattern($1, smbd_spool_t)
+	admin_pattern($1, samba_share_t)
+
+	admin_pattern($1, samba_var_t)
+	files_list_var($1)
 
+	admin_pattern($1, smbd_var_run_t)
 	files_list_pids($1)
-	admin_pattern($1, { winbind_var_run_t smbd_var_run_t swat_var_run_t nmbd_var_run_t })
 
+	admin_pattern($1, smbd_tmp_t)
 	files_list_tmp($1)
-	admin_pattern($1, { swat_tmp_t smbd_tmp_t winbind_tmp_t })
 
-	samba_run_smbcontrol($1, $2)
-	samba_run_winbind_helper($1, $2)
-	samba_run_smbmount($1, $2)
-	samba_run_net($1, $2)
+	admin_pattern($1, swat_var_run_t)
+
+	admin_pattern($1, swat_tmp_t)
+
+	admin_pattern($1, winbind_log_t)
+
+	admin_pattern($1, winbind_tmp_t)
+
+	admin_pattern($1, winbind_var_run_t)
+	admin_pattern($1, samba_unconfined_script_exec_t)
+
+	samba_systemctl($1)
+	admin_pattern($1, samba_unit_file_t)
+	allow $1 samba_unit_file_t:service all_service_perms;
 ')
